<script setup lang="ts">
    import { onBeforeMount, ref, toValue, watch } from 'vue'
    import { User } from '@/api/user/User'
    import { UserApi } from '@/api/user/UserApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SUserListItem from '@/serviceOffer/components/administration/SUserListItem.vue'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferInjectionKey,
    } from '@/shared/constants'

    import { ServiceOfferNamespaces } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { EditUserDto } from '@/api/user/EditUserDto'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import SearchField from '@/shared/search/components/SearchField.vue'
    import { useFilteredList } from '@/shared/search/composables/useFilteredList'
    import { useSearchField } from '@/shared/search/composables/useSearchField'
    import RouteNavigationDrawer from '@/serviceOffer/components/administration/SRouteNavigationDrawer.vue'
    import { isDefined, requiredInject } from '@/shared/helpers/types'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    const msal = useMsal()
    const userStore = useUserStore(msal)
    const users = ref<User[]>([])
    const filterQuery = ref<string>('')
    const filteredUsers = useFilteredList<User>(
        users,
        filterQuery,
        (filterQuery: string) => {
            return (user: User) => {
                return user.email
                    .toLowerCase()
                    .includes(toValue(filterQuery).toLowerCase())
            }
        }
    )

    const searchField = ref<InstanceType<typeof SearchField>>()
    const { loseFocus, expanded, toggleExpanded } = useSearchField(searchField)

    const userApi = new UserApi(msal)

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)

    const serviceOffer = requiredInject(serviceOfferInjectionKey)

    onBeforeMount(() => {
        watch(
            [() => msal.accounts, () => userStore.isImpersonating],
            () => {
                userApi
                    .getByServiceOffer(serviceOfferId.value)
                    .then((returnedUsers) => (users.value = returnedUsers))
            },
            { immediate: true }
        )
    })

    async function updateUser(user: User) {
        const userApi = new UserApi(msal)
        const updatedUserDto: EditUserDto = {
            email: user.email,
            roles: user.roles,
        }
        await userApi.updateUserByServiceOffer(
            serviceOfferId.value,
            user.id,
            updatedUserDto
        )
    }

    const removeUserFromList = (userWithRolesRemoved: User) => {
        users.value = users.value.filter(
            (user) => user.id !== userWithRolesRemoved.id
        )
    }

    const showRemoveUserRolesModal = ref(false)

    const selectedUser = ref<User>()

    async function removeSelectedUser() {
        if (selectedUser.value) {
            selectedUser.value.roles = []

            await updateUser(selectedUser.value)

            emitSnackBar(
                `L'utilisateur "${selectedUser.value.email}" a été retiré de l'offre de service ${serviceOffer.value?.title}`,
                'primary'
            )

            removeUserFromList(selectedUser.value)
        }
    }
</script>

<template>
    <route-navigation-drawer
        v-if="isDefined(serviceOffer)"
        page-title="Utilisateurs"
        :service-offer-id="serviceOfferId"
        :service-offer-type="serviceOffer.template"
        :show-title="searchField?.fullWidth"
    >
        <template #searchField>
            <search-field
                ref="searchField"
                v-model="filterQuery"
                :expanded="expanded"
                clearable
                @click:clear="filterQuery = ''"
                @click:icon="toggleExpanded"
                @focusout="loseFocus"
            />
        </template>
    </route-navigation-drawer>
    <v-main v-if="isDefined(serviceOffer)">
        <s-content-container>
            <h2 class="pt-3">{{ filteredUsers.length }} utilisateurs</h2>
            <v-list v-if="serviceOffer" :lines="false">
                <s-user-list-item
                    v-for="user in filteredUsers"
                    :key="user.id"
                    :available-roles="serviceOffer.availableRoles"
                    :model-value="user"
                    @update-user="
                        (updatedUser: User) => updateUser(updatedUser)
                    "
                >
                    <v-btn
                        icon="mdi-trash-can-outline"
                        color="error"
                        size="small"
                        variant="text"
                        data-cy="remove-user-button"
                        @click="
                            () => {
                                selectedUser = user
                                showRemoveUserRolesModal = true
                            }
                        "
                    >
                    </v-btn>
                </s-user-list-item>
            </v-list>
            <s-action-button
                icon="mdi-plus"
                label="Ajouter un utilisateur"
                data-cy="save-user-button"
                display="floating-fixed"
                position="right"
                :to="{
                    name: `${serviceOffer.template}/administration/utilisateurs/créer`,
                    params: {
                        serviceOfferId,
                        serviceOfferType:
                            ServiceOfferNamespaces.InterventionServiceOffer,
                    },
                }"
            >
            </s-action-button>
        </s-content-container>
        <v-dialog v-model="showRemoveUserRolesModal" width="auto">
            <v-card>
                <v-card-title class="text-h5"
                    >Retirer l'utilisateur ?
                </v-card-title>
                <v-card-text>
                    L'utilisateur
                    <strong>{{ selectedUser?.email }}</strong> n'aura plus accès
                    à l'offre de service
                    <strong>{{ serviceOffer?.title }}</strong
                    >.
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <s-action-button @click="showRemoveUserRolesModal = false">
                        Annuler
                    </s-action-button>

                    <s-action-button
                        color="error"
                        data-cy="confirm-remove-user-button"
                        @click="
                            () => {
                                removeSelectedUser()
                                showRemoveUserRolesModal = false
                            }
                        "
                    >
                        Retirer
                    </s-action-button>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-main>
</template>
